﻿using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

namespace cloddyMod
{
    public class cloddyMod : MonoBehaviour
    {
        // config
        public static float camSmoothness = 20f;
        public static float camRotation = 0f;
        // config done!!

        // mod tag
        public static string modTag = "[<color=green>CM</color>] ";

        public static bool holdingShift = false;
        public static bool Shift = false;
        public static bool Alt = false;
        public static bool Control = false;
        public static bool Modifier = false;

        public static bool KeyCheck(string _name, bool _held)
        {
            if (DialogBox.IsAnyDialogboxOpen || Global.ActiveUiBlock) return false;

            KeyCode xModifierx = KeyCode.None;

            Shift = Alt = Control = Modifier = false;
            Shift = (Input.GetKeyDown(KeyCode.LeftShift) || Input.GetKey(KeyCode.RightShift));
            Control = (Input.GetKeyDown(KeyCode.LeftControl) || Input.GetKey(KeyCode.RightControl));
            Alt = (Input.GetKeyDown(KeyCode.LeftAlt) || Input.GetKey(KeyCode.RightAlt));

            if (Input.GetKey(KeyCode.LeftAlt)) xModifierx = KeyCode.LeftAlt;
            if (Input.GetKey(KeyCode.RightAlt)) xModifierx = KeyCode.RightAlt;


            holdingShift = (Input.GetKey(KeyCode.RightShift) || Input.GetKey(KeyCode.LeftShift));

            if (_held)
            {
                if (InputSystem.Held(_name))
                {
                    // Make sure no modifier keys are being pressed unless its in the schematic
                    //
                    InputAction action = InputSystem.Actions[_name];

                    return (bool)(action.SecondaryKey != KeyCode.None || action.SecondaryKey == xModifierx);
                }
            }
            else
            {
                if (InputSystem.Down(_name))
                {
                    // Make sure no modifier keys are being pressed unless its in the schematic
                    //
                    InputAction action = InputSystem.Actions[_name];

                    return (bool)(action.SecondaryKey != KeyCode.None || action.SecondaryKey == xModifierx);
                }
            }
            return false;
        }

        public class cloddyModBehavior : MonoBehaviour
        {
            public void Update()
            {
                if (cloddyMod.KeyCheck("CM-CamSmoothConfig", false)) CamSmoothOpenConfig();
            }

            public void CamSmoothOpenConfig()
            {
                DialogBox dialog = null;
                dialog = DialogBoxManager.TextEntry(
                    "Set Camera Smoothing [d=20]",
                    "0.1 - 100, Smaller is smoother.",
                    new DialogButton("Save", true, new UnityAction[1] { (UnityAction)(() => SaveCamSmooth(dialog)) }),
                    new DialogButton("Cancel", true, (UnityAction[])Array.Empty<UnityAction>()));

                void SaveCamSmooth(DialogBox d)
                {
                    string intext = d.EnteredText;

                    if (float.TryParse(intext, out float n) && n >= 0.1f && n <= 100)
                    {
                        cloddyMod.camSmoothness = n;
                    }
                    else
                    {
                        ModAPI.Notify("Number should be larger than 0.1 and less than 100.");
                    }
                }
            }
        }

        public static void OnLoad()
        {
            BindKeys();
        }

        private static void BindKeys()
        {
            string[] KeySchematic =
            {
                "ResetCamera      > Reset Camera                            > LeftShift > LeftAlt",
                "SmoothCamera     > Smooth Camera                           > Semicolon",
                "CamSmoothConfig  > Smooth Camera Configuration             > None",
                "RotateCameraR    > Rotate Camera Right                     > None",
                "RotateCameraL    > Rotate Camera Left                      > None",
            };
            string inputKey;
            InputAction action;

            foreach (string keyMapping in KeySchematic)
            {
                string[] KeyParts = keyMapping.Split('>');

                inputKey = "CM-" + KeyParts[0].Trim();

                if (!InputSystem.Has(inputKey))
                {
                    ModAPI.RegisterInput("[CM] " + KeyParts[1].Trim(), inputKey, (KeyCode)Enum.Parse(typeof(KeyCode), KeyParts[2].Trim()));

                    if (KeyParts.Length == 4)
                    {
                        InputAction actionCreate = new InputAction(
                            (KeyCode)Enum.Parse(typeof(KeyCode), KeyParts[2].Trim()),
                            (KeyCode)Enum.Parse(typeof(KeyCode), KeyParts[3].Trim())
                        );


                        InputSystem.Actions.Add(inputKey, actionCreate);
                    }
                }
                else
                {
                    action = InputSystem.Actions[inputKey];
                    ModAPI.RegisterInput("[CM] " + KeyParts[1].Trim(), inputKey, action.Key);

                    InputAction actionNew = InputSystem.Actions[inputKey];
                    actionNew.SecondaryKey = action.SecondaryKey;
                }
            }
        }

        public static void Main()
        {
            string MT = cloddyMod.modTag;

            ModAPI.Register<cloddyModBehavior>();
            //ModAPI.RegisterTool<ClodWireTool>("CM Wire", "Used for several things in cloddyMod", ModAPI.LoadSprite("cameraView.png"));

            ModAPI.OnItemSpawned += (sender, args) =>
            {

                args.Instance.AddComponent<generalContextMenuStuff>();

                var PB = args.Instance.gameObject.GetComponent<PersonBehaviour>();
                if (PB)
                {
                    if (!PB.gameObject.GetComponent<humanContextMenuStuff>())
                    {
                        PB.gameObject.AddComponent<humanContextMenuStuff>();
                    }
                }
            };

            Camera.main.GetComponent<CameraControlBehaviour>().enabled = false;
            Camera.main.gameObject.GetOrAddComponent<CameraControlBehaviour2>();

            //Cam Object
            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = MT + "Camera",
        DescriptionOverride = "On activation, camera is forced to follow.",
        CategoryOverride = ModAPI.FindCategory("Machinery"),
        ThumbnailOverride = ModAPI.LoadSprite("cameraView.png"), //Doesn't exist yet!
        AfterSpawn = (Instance) =>
{
    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("camera.png");
    Instance.FixColliders();
    Instance.GetOrAddComponent<cameraObjectBehavior>();

}
    }
);

            //Zombie
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = MT + "Zombie",
                    NameToOrderByOverride = "cloddyMod",
                    DescriptionOverride = "Brraiinnsss...",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("zombieView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        foreach (var body in person.Limbs)
                        {
                            body.GetComponent<SkinMaterialHandler>().RottenProgress = 100f;
                            body.IsZombie = true;
                        }
                    }
                }
            );

            // Stop Sign
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), // derive from a syringe
                    NameOverride = MT + "Stop Sign",
                    DescriptionOverride = "You know the time!",
                    NameToOrderByOverride = "cloddyMod",
                    ThumbnailOverride = ModAPI.LoadSprite("stopSignView.png"),
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    AfterSpawn = (Instance) =>
                    {
                        var sr = Instance.GetComponent<SpriteRenderer>();
                        sr.material = ModAPI.FindMaterial("Sprites-Default");
                        sr.sprite = ModAPI.LoadSprite("stopSign.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<PolygonCollider2D>();
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1.05f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1.05f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 1.05f;
                    }
                }
            );

            // Stop Sign
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), // derive from a syringe
                    NameOverride = MT + "Damaged Planks",
                    NameToOrderByOverride = "cloddyMod",
                    DescriptionOverride = "Physically abused planks, at your disposal. Now you can use them for physical abuse against humans!",
                    ThumbnailOverride = ModAPI.LoadSprite("props\\bpView.png"),
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.AddComponent<RandomSpriteBehaviour>();

                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {

                        ModAPI.LoadSprite("props\\bp1.png"),
                        ModAPI.LoadSprite("props\\bp2.png"),
                        ModAPI.LoadSprite("props\\bp3.png"),
                        ModAPI.LoadSprite("props\\bp4.png"),
                        ModAPI.LoadSprite("props\\bp5.png"),
                        ModAPI.LoadSprite("props\\bp6.png"),
                        ModAPI.LoadSprite("props\\bp7.png"),
                        ModAPI.LoadSprite("props\\bp8.png"),
                        ModAPI.LoadSprite("props\\bp9.png"),
                        ModAPI.LoadSprite("props\\bp10.png"),
                        ModAPI.LoadSprite("props\\bp11.png"),
                        ModAPI.LoadSprite("props\\bp12.png"),

                        };
                        Instance.FixColliders();
                    }
                }
            );



            // ridiculous generator

            ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Generator"), // derive from a syringe
        NameOverride = "CRAZY INSANE GENERATOR!!!!!",
        NameToOrderByOverride = "cloddyMod",
        DescriptionOverride = "jesus christ why would you need this " + MT,
        ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
        CategoryOverride = ModAPI.FindCategory("null"),
        AfterSpawn = (Instance) =>
        {
            var sr = Instance.GetComponent<GeneratorBehaviour>();
            sr.TargetCharge = 99999999999999999f;
        }
    }
);

            //Skeleton
            ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = MT + "Skeleton",
                        NameToOrderByOverride = "cloddyMod",
                        DescriptionOverride = "Sending shivers down your spine.",
                        CategoryOverride = ModAPI.FindCategory("Entities"),
                        ThumbnailOverride = ModAPI.LoadSprite("skeletonView.png"),
                        AfterSpawn = (Instance) =>
                        {
                            var person = Instance.GetComponent<PersonBehaviour>();

                            foreach (var body in person.Limbs)
                            {
                                body.GetComponent<SkinMaterialHandler>().AcidProgress = 100f;
                            }
                        }
                    }
                );

            // Immortality Syringe
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
                NameOverride = MT + "Immortality Syringe",
                NameToOrderByOverride = "cloddyMod",
                DescriptionOverride = "Syringe full of immortality serum.",
                CategoryOverride = ModAPI.FindCategory("Biohazard"),
                ThumbnailOverride = ModAPI.LoadSprite("immortalitySyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    // destroy the existing syringe behaviour
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    // add the new syringe behaviour (unless it already exists)
                    Instance.GetOrAddComponent<ImmortalityS>();
                }
            }
            );

            // Coma Syringe

            ModAPI.RegisterLiquid(ComaSyringe.ComaSerum.ID, new ComaSyringe.ComaSerum());
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
                NameOverride = MT + "Coma Syringe",
                NameToOrderByOverride = "cloddyMod",
                DescriptionOverride = "Knocks out permanantly!!",
                CategoryOverride = ModAPI.FindCategory("Biohazard"),
                ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                    Instance.GetOrAddComponent<ComaSyringe>();
                }
            }
            );

            // Liquid Syringes

            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
                NameOverride = MT + "Beverage M04 Syringe",
                NameToOrderByOverride = "cloddyMod",
                DescriptionOverride = "Syringe full of beverage m04.",
                CategoryOverride = ModAPI.FindCategory("Biohazard"),
                ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                    Instance.GetOrAddComponent<BeverageM04S>();
                }
            }
            );
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Exotic Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of exotic liquid.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<ExoticLiquidS>();
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Inert Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of inert liquid.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<InertLiquidS>();
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Tritium Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of tritium.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<TritiumS>();
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Tritium Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of tritium.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<TritiumS>();
    }
}
);
            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Blood Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of human blood.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<HumanBloodS>();
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Gorse Blood Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of gorse blood.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<GorseBloodS>();
    }
}
);

            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), // derive from a syringe
    NameOverride = MT + "Oil Syringe",
    NameToOrderByOverride = "cloddyMod",
    DescriptionOverride = "Syringe full of oil.",
    CategoryOverride = ModAPI.FindCategory("Biohazard"),
    ThumbnailOverride = ModAPI.LoadSprite("missingicon.png"),
    AfterSpawn = (Instance) =>
    {
        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
        Instance.GetOrAddComponent<AndroidBloodS>();
    }
}
);
        }



    }

    class CameraControlBehaviour2 : MonoBehaviour
    {
        public float smoothness = 20f;
        public bool smooth = false;
        public float ZoomSpeed = 1f;
        public Vector3 oldMousePos;
        public Vector3 oldCamPos;
        public float targetZoom;
        public Vector3 targetPos;
        public float MinZoom = 0.001f;
        public float MaxZoom = float.MaxValue;
        public Bounds BoundingBox = new Bounds(new Vector3(595f, 497f, 0.0f), new Vector3(1200f, 990f, 0.0f));
        public float Extend = float.MaxValue;
        public float KeyboardPanSpeedMultiplier = 4f;
        public float KeyboardZoomSpeedMultiplier = 10f;
        public List<PhysicalBehaviour> CurrentlyFollowing = new List<PhysicalBehaviour>();
        public FollowingViewBehaviour followingViewBehaviour;
        public Vector3 MovementDelta;
        public Vector3 LastPos;

        public event EventHandler PostRender;

        private void Start()
        {
            this.targetZoom = Global.main.camera.orthographicSize;
            this.followingViewBehaviour = UnityEngine.Object.FindObjectOfType<FollowingViewBehaviour>();
        }

        private void LateUpdate()
        {


            smoothness = cloddyMod.camSmoothness;
            if (cloddyMod.KeyCheck("CM-SmoothCamera", false) == true && smooth == false)
            {
                smooth = true;
                ModAPI.Notify("Enabled Smooth Camera");
            }
            else if (cloddyMod.KeyCheck("CM-SmoothCamera", false) == true)
            {
                smooth = false;
                ModAPI.Notify("Disabled Smooth Camera");
            }

            this.CurrentlyFollowing = Camera.main.GetComponent<CameraControlBehaviour>().CurrentlyFollowing;

            if (this.CurrentlyFollowing.Count > 0)
                this.targetPos = this.GetAveragePosition();
            this.targetPos.z = -10f;
            Vector3 mousePosition = Input.mousePosition;
            bool flag1 = (double)mousePosition.x > 0.0 && (double)mousePosition.y > 0.0 && (double)mousePosition.x < (double)Screen.width && (double)mousePosition.y < (double)Screen.height;
            bool flag2 = ((Global.main.GetPausedMenu() ? 0 : (flag1 ? 1 : 0)) != 0);
            Camera camera = Global.main.camera;

            if (smooth == true)
            {
                camera.orthographicSize = Vector3.Lerp(new Vector3(camera.orthographicSize, camera.orthographicSize, camera.orthographicSize), new Vector3(Mathf.Clamp(targetZoom, MinZoom, float.MaxValue), Mathf.Clamp(targetZoom, MinZoom, float.MaxValue), Mathf.Clamp(targetZoom, MinZoom, float.MaxValue)), smoothness * Time.unscaledDeltaTime).x;
                Global.CameraPosition = Vector3.Lerp(Global.CameraPosition, targetPos, smoothness * Time.unscaledDeltaTime);
            }
            else
            {
                camera.orthographicSize = targetZoom;
                Global.CameraPosition = targetPos;
            }

            if (cloddyMod.camRotation != 0)
            {
                Camera.main.transform.eulerAngles = new Vector3(0, 0, cloddyMod.camRotation);
            }

            if (((DialogBox.IsAnyDialogboxOpen ? 0 : (!Global.ActiveUiBlock ? 1 : 0)) & (flag2 ? 1 : 0)) != 0)
            {
                if ((double)Mathf.Abs(Input.mouseScrollDelta.y) > 0.0 && !Global.main.UILock)
                    this.ZoomCamera(Input.mouseScrollDelta.y);

                if (InputSystem.Down("pan"))
                {
                    this.oldMousePos = Global.main.MousePosition;
                    this.oldCamPos = Global.CameraPosition;
                    this.CurrentlyFollowing.Clear();
                }
                if (InputSystem.Held("pan"))
                {
                    Global.CameraPosition = this.oldCamPos;
                    Vector3 vector3 = this.oldMousePos - camera.ScreenToWorldPoint(new Vector3(Input.mousePosition.x, Input.mousePosition.y, Global.CameraPosition.z));
                    Global.CameraPosition = this.oldCamPos + new Vector3(vector3.x, vector3.y, 0.0f);
                    this.targetPos = Global.CameraPosition;
                }
                if (InputSystem.Held("panLeft"))
                {
                    this.CurrentlyFollowing.Clear();
                    this.targetPos += this.KeyboardPanSpeedMultiplier * this.targetZoom * Time.unscaledDeltaTime * Vector3.left;
                }
                if (cloddyMod.KeyCheck("CM-ResetCamera", true) == true)
                {
                    Camera.main.transform.eulerAngles = new Vector3(0, 0, 0);
                    this.targetPos = new Vector2(0, 0);
                    this.targetZoom = 50;
                    cloddyMod.camRotation = 0;
                }
                if (cloddyMod.KeyCheck("CM-RotateCameraR", true) == true) cloddyMod.camRotation -= 0.2f;
                if (cloddyMod.KeyCheck("CM-RotateCameraL", true) == true) cloddyMod.camRotation += 0.2f;
                if (InputSystem.Held("panRight"))
                {
                    this.CurrentlyFollowing.Clear();
                    this.targetPos += this.KeyboardPanSpeedMultiplier * this.targetZoom * Time.unscaledDeltaTime * Vector3.right;
                }
                if (InputSystem.Held("panUp"))
                {
                    this.CurrentlyFollowing.Clear();
                    this.targetPos += this.KeyboardPanSpeedMultiplier * this.targetZoom * Time.unscaledDeltaTime * Vector3.up;
                }
                if (InputSystem.Held("panDown"))
                {
                    this.CurrentlyFollowing.Clear();
                    this.targetPos += this.KeyboardPanSpeedMultiplier * this.targetZoom * Time.unscaledDeltaTime * Vector3.down;
                }
                if (InputSystem.Held("zoomIn"))
                    this.ZoomCamera(Time.unscaledDeltaTime * this.KeyboardZoomSpeedMultiplier, false);
                if (InputSystem.Held("zoomOut"))
                    this.ZoomCamera(-Time.unscaledDeltaTime * this.KeyboardZoomSpeedMultiplier, false);
            }
            this.followingViewBehaviour.gameObject.SetActive(this.CurrentlyFollowing.Count > 0);
            Global.CameraPosition = Global.CameraPosition;
        }

        private void ZoomCamera(float i, bool cursorAsOrigin = true)
        {
            if (DialogBox.IsAnyDialogboxOpen || Global.ActiveUiBlock)
                return;
            float num = (float)((double)i * (double)this.ZoomSpeed * 0.100000001490116) * UserPreferenceManager.Current.ZoomSensitivity;

            if (this.targetZoom <= this.MinZoom)
            {
                this.targetZoom = this.MinZoom + 0.0001f;
            }
            else
            {
                this.targetZoom -= num * Global.main.camera.orthographicSize;
            }

            if ((((double)this.targetZoom >= (double)this.MaxZoom ? 0 : ((double)this.targetZoom > (double)this.MinZoom ? 1 : 0)) & (cursorAsOrigin ? 1 : 0)) == 0)
                return;
            this.targetPos += (Vector3)(Vector2)(Global.main.MousePosition - Global.CameraPosition) * num;
        }

        private void FixedUpdate()
        {
            if (Global.main.Paused)
                return;
            Vector3 position = this.transform.position;
            this.MovementDelta = position - this.LastPos;
            this.LastPos = position;
        }

        private void Update()
        {
            if (!Global.main.Paused)
                return;
            this.MovementDelta = new Vector3();
        }

        private Vector3 GetAveragePosition()
        {
            Vector3 zero = Vector3.zero;
            int count = this.CurrentlyFollowing.Count;
            for (int index = 0; index < this.CurrentlyFollowing.Count; ++index)
            {
                PhysicalBehaviour physicalBehaviour = this.CurrentlyFollowing[index];
                if (!(bool)(UnityEngine.Object)physicalBehaviour || physicalBehaviour.isDisintegrated)
                    --count;
                else
                    zero += physicalBehaviour.transform.position;
            }
            if (count != 0)
                return zero / (float)count;
            this.CurrentlyFollowing.Clear();
            return this.targetPos;
        }

        private void OnPostRender()
        {
            EventHandler postRender = this.PostRender;
            if (postRender == null)
                return;
            postRender((object)this, EventArgs.Empty);
        }
    }

    public class ImmortalityS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => ImmortalitySerum.ID;
    }

    public class BeverageM04S : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Chemistry.BeverageM04.ID;
    }

    public class HumanBloodS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Blood.ID;
    }
    public class AndroidBloodS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Oil.ID;
    }
    public class GorseBloodS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => GorseBlood.ID;
    }

    public class ExoticLiquidS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Chemistry.ExoticLiquid.ID;
    }

    public class InertLiquidS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Chemistry.InertLiquid.ID;
    }

    public class TritiumS : SyringeBehaviour
    {
        // provide the liquid ID for this syringe
        public override string GetLiquidID() => Chemistry.Tritium.ID;
    }




    public class ComaSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => ComaSerum.ID;

        public class ComaSerum : Liquid
        {
            public const string ID = "COMA SERUM [CM]";

            public ComaSerum()
            {
                Color = new UnityEngine.Color(0.3f, 0f, 0.66f);
            }

            //Called when this liquid enters a limb.
            //Note that this may be called quite often for the same container as liquid quickly moves in and out of it.
            public override void OnEnterLimb(LimbBehaviour limb)
            {
                //this is where syringes usually apply their effects.
                limb.Person.Consciousness = 0;
            }

            //Called every second by every container for every liquid it contains.
            public override void OnUpdate(BloodContainer container)
            {

                if (!(container is CirculationBehaviour circulationBehaviour))
                    return;


                OnEnterLimb(circulationBehaviour.Limb);

                //for syringe liquids, this is usually empty.
                //if you want a syringe effect to be continuously applied, you should implement the effects here instead.
                //make sure to check if the given container is actually a CirculationBehaviour.

                //do note that this has to call base.OnUpdate(container) if you are derving from TemporaryBodyLiquid
            }

            //Called when this liquid enters a container. Limbs are also containers. 
            //Note that this may be called quite often for the same container as liquid quickly moves in and out of it.
            public override void OnEnterContainer(BloodContainer container)
            {
                //for syringe liquids, this is usually empty.
            }

            //Called when this liquid exits a container. 
            //Note that this may be called quite often for the same container as liquid quickly moves in and out of it.
            public override void OnExitContainer(BloodContainer container)
            {
                //for syringe liquids, this is usually empty.
            }
        }
    }

    public class cameraObjectBehavior : MonoBehaviour
    {
        public bool rotateCam = false;
        public bool alwaysShow = true;


        public void Start()
        {

            var rotcam = new ContextMenuButton(() => this.rotateCam == false, "rotcam", "Enable rotation", "Makes the game camera rotate with this camera.", new UnityAction[1]
{
                (UnityAction) (() => {

                    this.rotateCam = true;
                })
})
            {
                LabelWhenMultipleAreSelected = "Enable rotation"
            };

            var rotcam2 = new ContextMenuButton(() => this.rotateCam == true, "rotcam2", "Disable rotation", "Makes the game camera not rotate with this camera.", new UnityAction[1]
{
                (UnityAction) (() => {

                    this.rotateCam = false;
                })
})
            {
                LabelWhenMultipleAreSelected = "Disable rotation"
            };

            var alsho = new ContextMenuButton(() => this.alwaysShow == true, "alsho", "Hide", "Makes the selected camera only appear in detail view.", new UnityAction[1]
{
                (UnityAction) (() => {

                    this.alwaysShow = false;
                })
})
            {
                LabelWhenMultipleAreSelected = "Hide"
            };
            var alsh2 = new ContextMenuButton(() => this.alwaysShow == false, "alsh2", "Show", "Makes the selected camera appear even when detail view is off.", new UnityAction[1]
{
                (UnityAction) (() => {

                    this.alwaysShow = true;
                })
})
            {
                LabelWhenMultipleAreSelected = "Show"
            };

            List<ContextMenuButton> buttonsList = this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons;

            buttonsList.Add(rotcam);
            buttonsList.Add(rotcam2);
            buttonsList.Add(alsho);
            buttonsList.Add(alsh2);
        }

        public void Update()
        {
            if (cloddyMod.camRotation != 0)
            {
                Camera.main.transform.eulerAngles = new Vector3(0, 0, cloddyMod.camRotation);
            }
            else if (enabled && rotateCam && Camera.main.GetComponent<CameraControlBehaviour>().CurrentlyFollowing.Contains(this.GetComponent<PhysicalBehaviour>()))
            {
                Camera.main.transform.eulerAngles = new Vector3(0, 0, this.gameObject.transform.eulerAngles.z + cloddyMod.camRotation);
            }

            if (Global.main.ShowLimbStatus || alwaysShow)
            {
                this.gameObject.GetComponent<SpriteRenderer>().enabled = true;
                this.gameObject.GetComponent<PhysicalBehaviour>().DisplayBloodDecals = true;
            }
            else
            {
                this.gameObject.GetComponent<SpriteRenderer>().enabled = false;
                this.gameObject.GetComponent<PhysicalBehaviour>().DisplayBloodDecals = false;
            }
        }

        public void Use(ActivationPropagation activation)
        {
            Camera.main.GetComponent<CameraControlBehaviour>().CurrentlyFollowing.Clear();
            Camera.main.GetComponent<CameraControlBehaviour>().CurrentlyFollowing.Add(this.GetComponent<PhysicalBehaviour>());
        }

    }

    public class generalContextMenuStuff : MonoBehaviour
    {
        public PhysicalBehaviour objecty;
        void Start()
        {
            objecty = gameObject.GetComponent<PhysicalBehaviour>();


            var modifycollisiongroupscm = new ContextMenuButton(() => SelectionController.Main.SelectedObjects.Count >= 2, "modifycollisiongroupscm", "Create Collision Group", "Set object collision grouping", new UnityAction[1]
{
                (UnityAction) (() => {



                        foreach (Collider2D co in objecty.colliders)
{
                            foreach (PhysicalBehaviour phys in SelectionController.Main.SelectedObjects)
{
                                foreach (Collider2D c in phys.colliders)
{
                    IgnoreCollisionStackController.RequestIgnoreCollision(co, c);
}
}
}
                })
})
            {
                LabelWhenMultipleAreSelected = "Create Collision Group"
            };

            var modifycollisiongroupscm2 = new ContextMenuButton(() => SelectionController.Main.SelectedObjects.Count >= 2, "modifycollisiongroupscm2", "Remove Collision Group", "Set object collision grouping", new UnityAction[1]
{
                (UnityAction) (() => {



                        foreach (Collider2D co in objecty.colliders)
{
                            foreach (PhysicalBehaviour phys in SelectionController.Main.SelectedObjects)
{
                                foreach (Collider2D c in phys.colliders)
{
                    IgnoreCollisionStackController.RequestDontIgnoreCollision(co, c);
}
}
}
                })
})
            {
                LabelWhenMultipleAreSelected = "Remove Collision Group"
            };

            var setweightcm = new ContextMenuButton("setweightcm", "Set weight", "Set object weight", new UnityAction[1]
{
                (UnityAction) (() => {

                DialogBox dialog = null;
                dialog = DialogBoxManager.TextEntry(
                    "Set " +objecty.gameObject.name +" Weight [d=" +objecty.InitialMass.ToString()+"]",
                    objecty.rigidbody.mass.ToString(),
                    new DialogButton("Save", true, new UnityAction[1] { (UnityAction)(() => SaveMass(dialog)) }),
                    new DialogButton("Cancel", true, (UnityAction[])Array.Empty<UnityAction>()));

                void SaveMass(DialogBox d)
                {
                    string intext = d.EnteredText;

                    if (float.TryParse(intext, out float n))
                    {
                        objecty.rigidbody.mass = n;
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Is the text you entered a number?");
                    }
                }
                })
})
            {
                LabelWhenMultipleAreSelected = "Set weights"
            };

            var setvelocitycm = new ContextMenuButton("setvelocitycm", "Set velocity", "Set object velocity (negative y is up)", new UnityAction[1]
{
                (UnityAction) (() => {


                DialogBox dialog = null;
                dialog = DialogBoxManager.TextEntry(
                    "Set " +objecty.gameObject.name +" velocity",
                    objecty.rigidbody.velocity.x.ToString() +"," +objecty.rigidbody.velocity.y.ToString(),
                    new DialogButton("Set", true, new UnityAction[1] { (UnityAction)(() => SetVelo(dialog)) }),
                    new DialogButton("Add", true, new UnityAction[1] { (UnityAction)(() => AddVelo(dialog)) }),
                    new DialogButton("Cancel", true, (UnityAction[])Array.Empty<UnityAction>()));

                void SetVelo(DialogBox d)
                {
                    string intext = d.EnteredText;

                    string[] g = intext.Split(',');

                    if (float.TryParse(g[0].Trim(), out float x) && float.TryParse(g[1].Trim(), out float y))
                    {
                                                objecty.rigidbody.velocity = new Vector2(x,y);
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Correct formatting: <X,Y>");
                    }
                }
                                    void AddVelo(DialogBox d)
                {
                    string intext = d.EnteredText;

                    string[] g = intext.Split(',');

                    if (float.TryParse(g[0].Trim(), out float x) && float.TryParse(g[1].Trim(), out float y))
                    {
                                                objecty.rigidbody.velocity += new Vector2(x,y);
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Correct formatting: <X,Y>");
                    }
                }


                })
})
            {
                LabelWhenMultipleAreSelected = "Set velocities"
            };

            var unbreakablecm = new ContextMenuButton(() => objecty.GetComponent<DestroyableBehaviour>() && objecty.GetComponent<DestroyableBehaviour>().OverallChance >= 1, "unbreakablecm", "Make unbreakable", "Makes the selected object unbreakable", new UnityAction[1]
{
                (UnityAction) (() => {

                    objecty.GetComponent<DestroyableBehaviour>().OverallChance = 0;
                })
})
            {
                LabelWhenMultipleAreSelected = "Make unbreakable"
            };

            var breakablecm = new ContextMenuButton(() => objecty.GetComponent<DestroyableBehaviour>() && objecty.GetComponent<DestroyableBehaviour>().OverallChance <= 0, "breakablecm", "Make breakable", "Makes the selected object breakable", new UnityAction[1]
{
                (UnityAction) (() => {

                    objecty.GetComponent<DestroyableBehaviour>().OverallChance = 1;
                })
})
            {
                LabelWhenMultipleAreSelected = "Make breakable"
            };

            var makeflammablecm = new ContextMenuButton(() => objecty.Properties.Flammability <= 0, "makeflammablecm", "Make type flammable", "Makes the selected object type(s) flammable", new UnityAction[1]
{
                (UnityAction) (() => {

                   objecty.Properties.Flammability = 1;
                })
})
            {
                LabelWhenMultipleAreSelected = "Make types flammable"
            };

            var makenonflammablecm = new ContextMenuButton(() => objecty.Properties.Flammability > 0, "makenonflammablecm", "Make type non-flammable", "Makes the selected object type(s) non-flammable", new UnityAction[1]
{
                (UnityAction) (() => {

                                       objecty.Properties.Flammability = 0;
                })
})
            {
                LabelWhenMultipleAreSelected = "Make types non-flammable"
            };

            var breakcm = new ContextMenuButton(() => objecty.GetComponent<DestroyableBehaviour>(), "breakcm", "Break", "Makes the selected object(s) break", new UnityAction[1]
    {
                (UnityAction) (() => {

                                        objecty.GetComponent<DestroyableBehaviour>().OverallChance = float.MaxValue;
                    objecty.GetComponent<DestroyableBehaviour>().Break();
                })
    })
            {
                LabelWhenMultipleAreSelected = "Break"
            };


            List<ContextMenuButton> buttonsList = objecty.ContextMenuOptions.Buttons;

            buttonsList.Add(modifycollisiongroupscm);
            buttonsList.Add(modifycollisiongroupscm2);
            buttonsList.Add(setweightcm);
            buttonsList.Add(setvelocitycm);
            buttonsList.Add(makeflammablecm);
            buttonsList.Add(makenonflammablecm);
            buttonsList.Add(unbreakablecm);
            buttonsList.Add(breakablecm);
            buttonsList.Add(breakcm);
        }

    }




    public class humanContextMenuStuff : MonoBehaviour
    {


        public class limbContextMenuStuff : MonoBehaviour
        {
            public LimbBehaviour limb;
            public PersonBehaviour PB;
            public humanContextMenuStuff c;
            public PhysicalBehaviour objecty;

            void Start()
            {
                limb = gameObject.GetComponent<LimbBehaviour>();
                PB = limb.Person;
                c = PB.GetComponent<humanContextMenuStuff>();
                objecty = limb.GetComponent<PhysicalBehaviour>();

                var modifycollisiongroupscm = new ContextMenuButton(() => SelectionController.Main.SelectedObjects.Count >= 2, "modifycollisiongroupscm", "this is a bug", "Set object collision grouping", new UnityAction[1]
    {
                (UnityAction) (() => {



                        foreach (Collider2D co in objecty.colliders)
{
                            foreach (PhysicalBehaviour phys in SelectionController.Main.SelectedObjects)
{
                                foreach (Collider2D c in phys.colliders)
{
                    IgnoreCollisionStackController.RequestIgnoreCollision(co, c);
}
}
}
                })
    })
                {
                    LabelWhenMultipleAreSelected = "Create Collision Group"
                };

                var modifycollisiongroupscm2 = new ContextMenuButton(() => SelectionController.Main.SelectedObjects.Count >= 2, "modifycollisiongroupscm2", "this is a bug", "Set object collision grouping", new UnityAction[1]
    {
                (UnityAction) (() => {



                        foreach (Collider2D co in objecty.colliders)
{
                            foreach (PhysicalBehaviour phys in SelectionController.Main.SelectedObjects)
{
                                foreach (Collider2D c in phys.colliders)
{
                    IgnoreCollisionStackController.RequestDontIgnoreCollision(co, c);
}
}
}
                })
    })
                {
                    LabelWhenMultipleAreSelected = "Remove Collision Group"
                };

                var setweightcm = new ContextMenuButton("setweightcm", "Set weight", "Set object weight", new UnityAction[1]
    {
                (UnityAction) (() => {

                DialogBox dialog = null;
                dialog = DialogBoxManager.TextEntry(
                    "Set " +objecty.gameObject.name +" Weight [d=" +objecty.InitialMass.ToString()+"]",
                    objecty.rigidbody.mass.ToString(),
                    new DialogButton("Save", true, new UnityAction[1] { (UnityAction)(() => SaveMass(dialog)) }),
                    new DialogButton("Cancel", true, (UnityAction[])Array.Empty<UnityAction>()));

                void SaveMass(DialogBox d)
                {
                    string intext = d.EnteredText;

                    if (float.TryParse(intext, out float n))
                    {
                        objecty.rigidbody.mass = n;
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Is the text you entered a number?");
                    }
                }
                })
    })
                {
                    LabelWhenMultipleAreSelected = "Set weights"
                };

                var setvelocitycm = new ContextMenuButton("setvelocitycm", "Set velocity", "Set object velocity (negative y is up)", new UnityAction[1]
    {
                (UnityAction) (() => {


                DialogBox dialog = null;
                dialog = DialogBoxManager.TextEntry(
                    "Set " +objecty.gameObject.name +" velocity",
                    objecty.rigidbody.velocity.x.ToString() +"," +objecty.rigidbody.velocity.y.ToString(),
                    new DialogButton("Set", true, new UnityAction[1] { (UnityAction)(() => SetVelo(dialog)) }),
                    new DialogButton("Add", true, new UnityAction[1] { (UnityAction)(() => AddVelo(dialog)) }),
                    new DialogButton("Cancel", true, (UnityAction[])Array.Empty<UnityAction>()));

                void SetVelo(DialogBox d)
                {
                    string intext = d.EnteredText;

                    string[] g = intext.Split(',');

                    if (float.TryParse(g[0].Trim(), out float x) && float.TryParse(g[1].Trim(), out float y))
                    {
                                                objecty.rigidbody.velocity = new Vector2(x,y);
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Correct formatting: <X,Y>");
                    }
                }
                                    void AddVelo(DialogBox d)
                {
                    string intext = d.EnteredText;

                    string[] g = intext.Split(',');

                    if (float.TryParse(g[0].Trim(), out float x) && float.TryParse(g[1].Trim(), out float y))
                    {
                                                objecty.rigidbody.velocity += new Vector2(x,y);
                    }
                    else
                    {
                        ModAPI.Notify("An error has occured. Correct formatting: <X,Y>");
                    }
                }


                })
    })
                {
                    LabelWhenMultipleAreSelected = "Set velocities"
                };


                var knockOut = new ContextMenuButton(() => PB.Consciousness == 1f, "knockOut", "Knock out", "Knock out the selected human", new UnityAction[1]
                {
                (UnityAction) (() => {
                    PB.Consciousness = 0f;
                    foreach (var limb in PB.Limbs)
                    {
                        limb.Numbness = 1f;
                    }
                })
                });
                knockOut.LabelWhenMultipleAreSelected = "Knock out";

                var makeflammablecm = new ContextMenuButton(() => limb.GetComponent<PhysicalBehaviour>().Properties.Flammability <= 0, "makeflammablecm", "Make type flammable", "Makes the selected object type(s) flammable", new UnityAction[1]
{
                (UnityAction) (() => {

                   limb.GetComponent<PhysicalBehaviour>().Properties.Flammability = 1;
                })
})
                {
                    LabelWhenMultipleAreSelected = "Make types flammable"
                };

                var makenonflammablecm = new ContextMenuButton(() => limb.GetComponent<PhysicalBehaviour>().Properties.Flammability > 0, "makenonflammablecm", "Make type non-flammable", "Makes the selected object type(s) non-flammable", new UnityAction[1]
    {
                (UnityAction) (() => {

                                       limb.GetComponent<PhysicalBehaviour>().Properties.Flammability = 0;
                })
    })
                {
                    LabelWhenMultipleAreSelected = "Make types non-flammable"
                };

                var dismember = new ContextMenuButton("dismember", "Dismember", "Dismember the selected limb", new UnityAction[1]
{
                (UnityAction) (() => {
                        limb.BreakingThreshold = 0f;
                })
});
                dismember.LabelWhenMultipleAreSelected = "Dismember";


                List<ContextMenuButton> buttonsList = limb.PhysicalBehaviour.ContextMenuOptions.Buttons;

                buttonsList.Add(knockOut);
                buttonsList.Add(dismember);
                buttonsList.Add(modifycollisiongroupscm);
                buttonsList.Add(modifycollisiongroupscm2);
                buttonsList.Add(setweightcm);
                buttonsList.Add(setvelocitycm);
                buttonsList.Add(makeflammablecm);
                buttonsList.Add(makenonflammablecm);
            }
        }

        public PersonBehaviour PB;

        void Start()
        {
            PB = gameObject.GetComponent<PersonBehaviour>();

            foreach (var limb in PB.Limbs)
            {
                if (!limb.gameObject.GetComponent<limbContextMenuStuff>())
                {
                    limb.gameObject.AddComponent<limbContextMenuStuff>();
                }
            }
        }
    }


    public class ClodWireTool : DistanceWireTool
    {
        private void Awake()
        {
            this.WireMaterial = Resources.Load<Material>("Materials/Cable");
            this.WireColor = new Color(0.25f, 0.5f, 1);
        }

        protected override void OnJointCreate(DistanceJoint2D joint)
        {
            CableBehaviour cableBehaviour = joint.gameObject.AddComponent<CableBehaviour>();
            UndoControllerBehaviour.RegisterAction((IUndoableAction)new ObjectCreationAction(cableBehaviour, "cable"));
            this.WireColor = new Color(0.25f, 0.5f, 1);
            cableBehaviour.WireMaterial = this.WireMaterial;
            cableBehaviour.WireWidth = this.WireWidth;
            cableBehaviour.typedJoint = joint;
        }
    }
}